Summary:        Provides Moose-like method modifiers
Name:           perl-Class-Method-Modifiers
Version:        2.13
Release:        5%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/dist/Class-Method-Modifiers
Source0:        https://cpan.metacpan.org/authors/id/E/ET/ETHER/Class-Method-Modifiers-%{version}.tar.gz

BuildRequires:  coreutils findutils make perl-generators perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) perl(strict) perl(warnings) perl(B) perl(Carp)
BuildRequires:  perl(Exporter) perl(File::Spec) perl(if)
# For test suite
BuildRequires:  perl(base) perl(Test::Fatal) perl(Test::Needs)
BuildRequires:  perl(Test::More) >= 0.88
Requires:       perl(B) perl(Carp) perl(Exporter)
BuildArch:      noarch

%description
Method modifiers are a convenient feature from the CLOS (Common Lisp Object System) world.

In its most basic form, a method modifier is just a method that calls $self->SUPER::foo(@_). 
I for one have trouble remembering that exact invocation, so my classes seldom re-dispatch 
to their base classes. Very bad!

Class::Method::Modifiers provides three modifiers: before, around, and after. before and 
after are run just before and after the method they modify, but can not really affect that 
original method. around is run in place of the original method, with a hook to easily call 
that original method. See the "MODIFIERS" section for more details on how the particular 
modifiers work.

%prep
%setup -q -n Class-Method-Modifiers-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING README t/
%{perl_vendorlib}/Class/
%{_mandir}/man3/Class::Method::Modifiers.3*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 15 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.13-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13-2
- Rebuilt for OpenCloudOS Stream 23

* Tue May 10 2022 Xiaojie Chen <jackxjchen@tencent.com> - 2.13-1
- Initial build
